package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.CodeItemMapper;
import com.sa.ibiz.demo.demo.domain.CodeItem;
import com.sa.ibiz.demo.demo.service.CodeItemService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.CodeItemSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.CodeItemService;
import com.sa.ibiz.demo.demo.service.CodeListService;

/**
 * 实体[CodeItem] 服务对象接口实现
 */
@Service
public class CodeItemServiceImpl extends ServiceImplBase<CodeItemMapper, CodeItem> implements CodeItemService{

    @Autowired
    private CodeItemService pcodeitemService;
    @Autowired
    private CodeListService codelistService;

    @Resource
    private CodeItemMapper codeitemMapper;


    @Override
    public boolean create(CodeItem et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(CodeItem et){
        this.beforeUpdate(et);
		this.codeitemMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(CodeItem et){
		return et.getCodeitemid();  
    }

    @Override
    public boolean getDraft(CodeItem et)  {
    if((!StringUtils.isEmpty(et.getPcodeitemid())) && et.getPcodeitem() == null){
            try {
                et.setPcodeitem(pcodeitemService.getById(et.getPcodeitemid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getCodelistid())) && et.getCodelist() == null){
            try {
                et.setCodelist(codelistService.getById(et.getCodelistid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<CodeItem> listDefault(CodeItemSearchFilter filter) {
		return codeitemMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<CodeItem> searchDefault(CodeItemSearchFilter filter) {
		return codeitemMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}


	public List<CodeItem> listCurCL(CodeItemSearchFilter filter) {
		return codeitemMapper.searchCurCL(filter,filter.getSelectCond());
	}

	public Page<CodeItem> searchCurCL(CodeItemSearchFilter filter) {
		return codeitemMapper.searchCurCL(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return codeitemMapper.selectRow(sql);
    }

 }